package com.javacodegeeks;

import java.util.*;

public class PriorityQueueExample {

    public static void main(String[] args) {
        defaultConstructor();
        initializeWithList();
        PriorityQueue priorityQueue = new PriorityQueue(20);
        PriorityQueue priorityQueue2 = new PriorityQueue(20, Comparator.comparingInt(Customer::getId));
        PriorityQueue priorityQueue3 = new PriorityQueue(priorityQueue);
        initializeWithSortedSet();
        add();
    }

    private static void add() {
        PriorityQueue pq = new PriorityQueue();
        pq.add("Java Code Geeks");
        pq.forEach(System.out::println);
    }

    private static void initializeWithSortedSet() {
        SortedSet sortedSet = new TreeSet();
        sortedSet.add("ten");
        sortedSet.add("eleven");
        sortedSet.add("four");
        PriorityQueue priorityQueue4 = new PriorityQueue(sortedSet);
        priorityQueue4.forEach(System.out::println);
    }

    private static void initializeWithList() {
        final List<Integer> list = Arrays.asList(10, 1, 100);
        PriorityQueue priorityQueue = new PriorityQueue(list);
        priorityQueue.forEach(System.out::println);
    }

    private static void defaultConstructor() {
        PriorityQueue priorityQueue = new PriorityQueue();
        priorityQueue.add("three");
        priorityQueue.add("two");
        priorityQueue.add("one");
        System.out.println("First element: " + priorityQueue.poll());
        System.out.println("Second element: " + priorityQueue.poll());
        System.out.println("Third element: " + priorityQueue.poll());
    }

    class Customer {
        int id;
        String name;

        public int getId() {
            return id;
        }

        public String getName() {
            return name;
        }
    }
}
